OGRE: Ogre::StaticFaceGroup Struct Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::StaticFaceGroup Struct Reference
Core » Scene

Collects a group of static i.e. More...

`#include <OgreStaticFaceGroup.h>`

## Public Attributes
int | elementStart
| Index into a buffer containing vertex indices.
FaceGroupType | fType
bool | isSky
| Is this a sky surface?
ResourceHandle | materialHandle
| Handle to material used by this group.
int | numElements
| The number of vertex indices.
int | numVertices
| The range of vertices in the buffer this facegroup references.
PatchSurface * | patchSurf
| Patch surface (only applicable when fType = FGT_PATCH).
Plane | plane
int | vertexStart
| Index into a buffer containing vertex definitions.

## Detailed Description

Collects a group of static i.e.

immovable faces together which have common properties like the material they use, the plane they lie on.

Whilst for discrete geometry (i.e. movable objects) groups of faces are held in the SubMesh class, for immovable objects like scenery there needs to ba little more flexibility in the grouping since the group is likely to be a small part of a huge set of geometry. In addition, because the faces are unmoving certain optimisations can be performed, e.g. precalculating a world-coordinate bounding box and normal.

  Exactly how this class is used depends on the format of the large static geometry used in the level. An example would be the use of this class in the BspNode class for indoor levels. For flexibility and efficiency, it is not assumed that this class holds details of the vertices itself, or in fact that it holds the vertex indices itself. Everything is manipulated via pointers so if you want this class to point into a block of geometry data it can.

## Member Data Documentation

## ◆ fType

FaceGroupType Ogre::StaticFaceGroup::fType

Referenced by operator<<.

## ◆ isSky

bool Ogre::StaticFaceGroup::isSky

Is this a sky surface?

## ◆ vertexStart

int Ogre::StaticFaceGroup::vertexStart

Index into a buffer containing vertex definitions.

Because we're dealing with subsets of large levels this is likely to be part-way through a huge vertex buffer.

Referenced by operator<<.

## ◆ numVertices

int Ogre::StaticFaceGroup::numVertices

The range of vertices in the buffer this facegroup references.

This is really for copying purposes only, so that we know which subset of vertices to copy from our large-level buffer into the rendering buffer.

Referenced by operator<<.

## ◆ elementStart

int Ogre::StaticFaceGroup::elementStart

Index into a buffer containing vertex indices.

This buffer may be individual to this group or shared for memory allocation efficiency.The vertex indexes are relative the the mVertexStart pointer, not to the start of the large-level buffer, allowing simple reindexing when copying data into rendering buffers. This is only applicable to FGT_FACE_LIST face group types.

Referenced by operator<<.

## ◆ numElements

int Ogre::StaticFaceGroup::numElements

The number of vertex indices.

This is only applicable to FGT_FACE_LIST face group types.

Referenced by operator<<.

## ◆ materialHandle

ResourceHandle Ogre::StaticFaceGroup::materialHandle

Handle to material used by this group.

Note the use of the material handle rather than the material name - this is for efficiency since there will be many of these.

Referenced by operator<<.

## ◆ plane

Plane Ogre::StaticFaceGroup::plane

Referenced by operator<<.

## ◆ patchSurf

PatchSurface* Ogre::StaticFaceGroup::patchSurf

Patch surface (only applicable when fType = FGT_PATCH).

The documentation for this struct was generated from the following file:

- OgreStaticFaceGroup.h